/*
 * exit.c
 *
 * Copyright (C) 2017 Aleksandar Andrejevic <theflash@sdf.lonestar.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <monolithium.h>

static void (*atexit_functions[ATEXIT_MAX])(void);
static int num_atexit_functions = 0;

int atexit(void (*function)(void))
{
    if (num_atexit_functions == ATEXIT_MAX) return -1;
    atexit_functions[num_atexit_functions++] = function;
    return 0;
}

void __attribute__((__noreturn__)) exit(int status)
{
    while (num_atexit_functions) atexit_functions[--num_atexit_functions]();

    syscall_terminate(INVALID_HANDLE, status);
    for (;;);
}
